/******************************************************************************
 * DO NOT SUBMIT.
 * DO NOT MODIFY.
 ******************************************************************************/

public class Coordinate {
    private static final int EARTH_RADIUS = 6371000;

    private double lon;
    private double lat;
    private double alt;

    public Coordinate(double longitude, double latitude, double altitude) { 
        this.lon = longitude;
        this.lat = latitude;
        this.alt = altitude;
    }

    public double getLon() {
        return this.lon;
    }

    public double getLat() {
        return this.lat;
    }

    public double getAlt() {
        return this.alt;
    }

    public String toString() {
        return this.lon + "," + this.lat + "," + this.alt;
    }

    public double haversineDist(Coordinate that) {
        double lon = that.getLon();
        double lat = that.getLat();

        double dLat = Math.toRadians(lat - this.lat);
        double dLon = Math.toRadians(lon - this.lon);
        double a = Math.sin(dLat / 2.0) * Math.sin(dLat / 2.0) +
            Math.cos(Math.toRadians(this.lat)) * Math.cos(Math.toRadians(lat)) *
            Math.sin(dLon / 2.0) * Math.sin(dLon / 2.0);
        double c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
        return EARTH_RADIUS * c;
    }

    public static String KMLHeader() {
        return "<?xml version=\"1.0\" encoding=\"UTF-8\"?><kml xmlns=\"http://www.opengis.net/kml/2.2\" xmlns:kml=\"http://www.opengis.net/kml/2.2\" xmlns:gx=\"http://www.google.com/kml/ext/2.2\"><Document><Style id=\"trackLine\"><LineStyle><width>3</width><color>ff000000</color></LineStyle></Style><Folder><name>Path</name><Placemark><name>Track</name><styleUrl>#trackLine</styleUrl><LineString><altitudeMode>clampToGround</altitudeMode><coordinates>";
    }

    public static String KMLFooter() {
        return "</coordinates></LineString></Placemark></Folder></Document></kml>";
    }
}
